<?php
/****** 基本設定 ********/

/* 校內 Windows AD 主機的資訊 */
//LDAP server 的 IP
$LDAP_IP="163.17.xx.xx";
//LDAP server 的 PORT
$LDAP_port=389;
//Windows AD LDAP 帳號的後綴字
$Base_suffix="xxxx.xxx.xxx.xx";
//Windows AD 上的對應 ASP 程式 URL
$rest_chpasswd_url="http://xxx.xxx.xxx.xxx/passwd/rest_change_passwd.aspx";

/* 校務雲端主機的 API 資訊 */
// 更改為學校的 API ID
$client_id = 'b5fb78c7d9c0487fd25xxxxxxxxxxxxxx';
// 更改為學校的 API 密碼
$client_secret = 'a46105cc9b492e6xxxxxxxxxxxxxxxxxxx';


/***********************  程式開始 以下請勿更動 *****************************/

if ($_POST['userid']!='') {

    //身分
    $user_kind=$_POST['user_kind'];
    //帳號
    $userid=$_POST['userid'];
    //要送到 CS 的帳號, 如果是學生帳號, 前面要加 "年度-"
    $cs_userid=($user_kind=='student')?(substr($userid,0,3)."-".$userid):$userid;

    //密碼
    $password=$_POST['password'];
    //新密碼1
    $newpassword1=$_POST['newpassword1'];
    //新密碼2
    $newpassword2=$_POST['newpassword2'];

    if ($newpassword1===$newpassword2) {

        $ldaprdn_ad=$userid."@".$Base_suffix;
        //先 BIND LDAP 帳號, 能正常 BIND 表示帳碼密碼無誤
        $ldap_server = ldap_connect($LDAP_IP,$LDAP_port);
        ldap_set_option($ldap_server, LDAP_OPT_PROTOCOL_VERSION, 3);
        ldap_set_option($ldap_server, LDAP_OPT_REFERRALS, 0);
        $BIND=@ldap_bind($ldap_server, $ldaprdn_ad, $password);

        if ($BIND) {

            $ch = curl_init();

            //修改 LDAP 中的密碼
            //要 POST 的資訊
            $POST_DATA['domainname']=$Base_suffix;
            $POST_DATA['username']=$userid;
            $POST_DATA['password']=$password;
            $POST_DATA['newpassword']=$newpassword1;

            $api_url=$rest_chpasswd_url;

            curl_setopt($ch, CURLOPT_CUSTOMREQUEST,  "POST");    //可用 GET , PUT , POST , DELETE 等 method
            curl_setopt($ch, CURLOPT_POSTFIELDS,$POST_DATA);

            //curl_setopt($ch, CURLOPT_HEADER, 0);
            //curl_setopt($ch, CURLOPT_HTTPHEADER, array('S_ID:'.$api_id,'S_PWD:'.$api_pwd));

            curl_setopt($ch, CURLOPT_URL, $api_url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

            $receive=curl_exec($ch);

            //LDAP密碼更改成功, 繼續處理校務雲端系統
            if ($receive==1) {
                $return_data="LDAP 主機帳號 ".$userid." 的密碼變更成功!";

                // =================================================

                // API NAME
                $api_name = '/change-password';

                // API URL
                $api_url = 'https://api.tc.edu.tw';

                // Patch data
                $user=[
                    [
                        'account'=>$cs_userid,
                        'password'=>$newpassword1,
                    ]
                ];
                $patch_data=json_encode($user);

                // 建立 CURL 連線
                $ch_cs = curl_init();
				//以下這兩行, 略過憑證檢查的有效性
				curl_setopt($ch_cs,CURLOPT_SSL_VERIFYHOST,0);
				curl_setopt($ch_cs,CURLOPT_SSL_VERIFYPEER,0);
                // 取 access token
                curl_setopt($ch_cs, CURLOPT_URL, $api_url."/oauth?authorize");

                // 設定擷取的URL網址
                curl_setopt($ch_cs, CURLOPT_POST, TRUE);

                // the variable
                curl_setopt($ch_cs, CURLOPT_RETURNTRANSFER, TRUE);


                curl_setopt($ch_cs, CURLOPT_POSTFIELDS, array(
                    'client_id' => $client_id,
                    'client_secret' => $client_secret,
                    'grant_type' => 'client_credentials'
                ));

                $data = curl_exec($ch_cs);
                $data = json_decode($data);

                $access_token = $data->access_token;

                $authorization = "Authorization: Bearer ".$access_token;

                curl_setopt($ch_cs, CURLOPT_URL, $api_url.$api_name);
                curl_setopt($ch_cs, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization )); // **Inject Token into Header**
                curl_setopt($ch_cs, CURLOPT_CUSTOMREQUEST, "PATCH");
                curl_setopt($ch_cs, CURLOPT_POST, TRUE);
                curl_setopt($ch_cs, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch_cs, CURLOPT_POSTFIELDS,$patch_data);

                //curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
                $result = curl_exec($ch_cs);

                $result=(array)json_decode($result);
                //print_r($result);
                $return_data.="<br>校務雲端系統中 ".$cs_userid." 的密碼同步變更 ".(($result['total_items']==1)?"成功!":"失敗");

            } else {
                $return_data="LDAP主機密碼變更失敗!!";
            }

        } else {
            $return_data="密碼錯誤!";
        }
    } else {
        $return_data="要修改的密碼有誤!!";
    }
}
?>
<html>
<head>
    <title>同步修改登入密碼</title>
    <style>
        .section {
            width: 700px;
            height: 600px;
            position: absolute;
            top: 50%;
            left:50%;
            margin: -300px 0 0 -350px;
            display: table;
        }

    </style>
</head>
<body>
<form method="post" name="myform" onsubmit="return CheckInput()">
    <div class="section">
        <div style="text-align: center">
            <h2 style="color:#0000DD">校內主機 & CS雲端校務系統</h2>
            <h1>同步修改登入密碼</h1>
        </div>
        <div style="margin: 10px">
            <table border="0" style="margin-left: auto;margin-right: auto">
                <tr>
                    <td valign="top">請確認您的身分</td>
                    <td valign="top">
                        <div>
                            <input type="radio" name="user_kind" value="teacher">教師
                            <input type="radio" name="user_kind" value="student">學生
                        </div>
                        <div>
                            <span id="user_kind_message" style="color:#FF0000"></span>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td valign="top">登入帳號代碼</td>
                    <td valign="top">
                        <div>
                            <input type="text" name="userid" style="width:200px">
                        </div>
                        <div>
                            <span id="userid_message" style="color:#FF0000"></span>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td valign="top">校內LDAP密碼</td>
                    <td valign="top">
                        <div>
                            <input type="password" name="password" style="width:200px">
                        </div>
                        <div>
                            <span id="password_message" style="color:#FF0000"></span>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td valign="top">新密碼</td>
                    <td valign="top">
                        <div>
                            <input type="password" name="newpassword1" style="width:200px">
                        </div>
                        <div>
                            <span id="newpassword1_message" style="color:#FF0000"></span>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td valign="top">新密碼再確認</td>
                    <td valign="top">
                        <div>
                            <input type="password" name="newpassword2" style="width:200px">
                        </div>
                        <div>
                            <span id="newpassword2_message" style="color:#FF0000"></span>
                        </div>
                    </td>
                </tr>
            </table>
        </div>
        <div style="text-align:center;margin: 10px">
            <input type="submit" value="確認修改">
        </div>
        <?php
        if ($return_data!='') {
            ?>
            <div style="text-align:center;color:#FF0000">
                <?php echo $return_data ?>				
            </div>
            <?php
        }
        ?>
        <div style="margin: 10px;line-height: normal">
            <p>注意事項：</p>
            <ol>
                <li>使用本頁面進行密碼變更，會同時變更<span style="color:#AA0000">校內 LDAP 帳號密碼</span>及<span style="color:#AA0000">臺中市雲端校務系統同一帳號代碼</span>的密碼。</li>
                <li>請務必確認您的校內的 LDAP 帳號代碼與臺中市雲端校務系統 ( <a href="https://school.tc.edu.tw/" target="_blank">https://school.tc.edu.tw</a> ) 的帳號代碼是相同的。</li>
				<li>密碼變更原則是: 以校內 LDAP 密碼為主，變更成功後才呼叫雲端校務系統同步變更。
                <li>密碼長度最少 6 個字元，最多 20 個字元。</li>
                <li>建議密碼至少混合數字與英文字母，增加密碼複雜度，提高安全。</li>
            </ol>
        </div>
    </div>
</form>
</body>
</html>
<Script style="text/javascript">

    function CheckInput() {
        var complete=1;
        var obj=document.getElementsByName("user_kind");
        var user_kind='';
        for (i=0;i<obj.length;i++) {
            if (obj[i].checked) {
                user_kind=obj[i].value;
            }
        }

        if (user_kind=='') {
            document.getElementById("user_kind_message").innerHTML="請點選身分別!";
            complete=0;
        } else {
            document.getElementById("user_kind_message").innerHTML="";
        }

        if (document.myform.userid.value=='') {
            document.getElementById("userid_message").innerHTML="請輸入帳號!";
            complete=0;
        } else {
            document.getElementById("userid_message").innerHTML="";
        }

        if (document.myform.password.value=='') {
            document.getElementById("password_message").innerHTML="請輸入校內LDAP密碼!";
            complete=0;
        } else {
            document.getElementById("password_message").innerHTML="";
        }

        if (document.myform.newpassword1.value=='') {
            document.getElementById("newpassword1_message").innerHTML="請輸入新密碼!";
            complete=0;
        } else {
            document.getElementById("newpassword1_message").innerHTML="";
        }

        if (document.myform.newpassword2.value=='') {
            document.getElementById("newpassword2_message").innerHTML="請輸入新密碼確認!";
            complete=0;
        } else {
            document.getElementById("newpassword2_message").innerHTML="";
        }

        var newpassword1=document.myform.newpassword1.value;
        var newpassword2=document.myform.newpassword2.value;

        if (newpassword1!=newpassword2) {
            complete=0;
            document.getElementById("newpassword1_message").innerHTML="新密碼與新密碼確認不相同, 請重新輸入!";
            document.getElementById("newpassword2_message").innerHTML="新密碼與新密碼確認不相同, 請重新輸入!";
            document.myform.newpassword1.value='';
            document.myform.newpassword2.value='';
        }

        if (complete==0) {
            return false;
        } else {
            if ( newpassword1.length<6 ) {
                document.getElementById("newpassword1_message").innerHTML="新密碼長度太短, 請重新輸入!";
                document.myform.newpassword1.value='';
                document.myform.newpassword2.value='';
                return false;
            }
            if ( newpassword1.length>20 ) {
                document.getElementById("newpassword1_message").innerHTML="新密碼長度太長, 請重新輸入!";
                document.myform.newpassword1.value='';
                document.myform.newpassword2.value='';
                return false;
            }

            return true;

        }

    }
</Script>